<?php

/* Affirm 2019 */

class ControllerPaymentAffirm extends Controller {

    private $error = array();

    public function index() {
        $this->load->language('payment/affirm');
        $data['title'] = $this->language->get('title');
        $this->document->setTitle($data['title']);
        $this->load->model('setting/setting');
        $this->load->model('payment/affirm');
        $this->load->model('localisation/order_status');
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('affirm', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'] . '&type=payment', true));
        }
        $data['heading_title'] = $this->language->get('affirm_title');
        $data['affirm_title'] = $this->language->get('affirm_title');
        $data['text_edit'] = $this->language->get('text_edit');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_all_zones'] = $this->language->get('text_all_zones');
        $data['text_sandbox_mode'] = $this->language->get('text_sandbox_mode');
        $data['text_affirm_true'] = $this->language->get('text_affirm_true');
        $data['text_affirm_no_status_change_on'] = $this->language->get('text_affirm_no_status_change_on');
        $data['text_affirm_no_status_change_off'] = $this->language->get('text_affirm_no_status_change_off');
        $data['text_affirm_false'] = $this->language->get('text_affirm_false');
        $data['text_yes'] = $this->language->get('text_yes');
        $data['text_no'] = $this->language->get('text_no');
        $data['text_live_mode'] = $this->language->get('text_live_mode');
        $data['text_capture'] = $this->language->get('text_capture');
        $data['text_authorization'] = $this->language->get('text_authorization');
        $data['text_sale'] = $this->language->get('text_sale');
        $data['text_affirm_enhanced_analytics'] = $this->language->get('text_affirm_enhanced_analytics');
        $data['text_affirm_enhanced_analytics_on'] = $this->language->get('text_affirm_enhanced_analytics_on');
        $data['text_affirm_enhanced_analytics_off'] = $this->language->get('text_affirm_enhanced_analytics_off');
        $data['entry_affirm_enhanced_analytics'] = $this->language->get('entry_affirm_enhanced_analytics');
        $data['entry_affirm_modal_checkout'] = $this->language->get('entry_affirm_modal_checkout');
        $data['entry_affirm_no_status_change'] = $this->language->get('entry_affirm_no_status_change');
        $data['entry_affirm_order_authorization_status'] = $this->language->get('entry_affirm_order_authorization_status');
        $data['entry_affirm_order_capture_status'] = $this->language->get('entry_affirm_order_capture_status');
        $data['entry_affirm_order_refund_status'] = $this->language->get('entry_affirm_order_refund_status');
        $data['entry_affirm_order_void_status'] = $this->language->get('entry_affirm_order_void_status');
        $data['entry_affirm_color'] = $this->language->get('entry_affirm_color');
        $data['entry_affirm_order_update_status'] = $this->language->get('entry_affirm_order_update_status');
        $data['text_affirm_color_default'] = $this->language->get('text_affirm_color_default');
        $data['text_affirm_color_black'] = $this->language->get('text_affirm_color_black');
        $data['text_affirm_color_white'] = $this->language->get('text_affirm_color_white');
        $data['text_affirm_type_logo'] = $this->language->get('text_affirm_type_logo');
        $data['text_affirm_type_symbol'] = $this->language->get('text_affirm_type_symbol');
        $data['text_affirm_type_text'] = $this->language->get('text_affirm_type_text');
        $data['entry_email'] = $this->language->get('entry_email');
        $data['entry_affirm_product_ala'] = $this->language->get('entry_affirm_product_ala');
        $data['entry_affirm_shopping_cart_ala'] = $this->language->get('entry_affirm_shopping_cart_ala');
        $data['entry_affirm_mini_cart_ala'] = $this->language->get('entry_affirm_mini_cart_ala');
        $data['entry_affirm_category_product_ala'] = $this->language->get('entry_affirm_category_product_ala');
        $data['entry_affirm_featured_product_ala'] = $this->language->get('entry_affirm_featured_product_ala');
        $data['entry_affirm_bestselling_product_ala'] = $this->language->get('entry_affirm_bestselling_product_ala');
        $data['entry_affirm_latest_product_ala'] = $this->language->get('entry_affirm_latest_product_ala');
        $data['entry_affirm_special_product_ala'] = $this->language->get('entry_affirm_special_product_ala');
        $data['entry_affirm_comparison_product_ala'] = $this->language->get('entry_affirm_comparison_product_ala');
        $data['entry_affirm_manufacturer_product_ala'] = $this->language->get('entry_affirm_manufacturer_product_ala');
        $data['entry_affirm_related_product_ala'] = $this->language->get('entry_affirm_related_product_ala');
        $data['entry_affirm_checkout_confirmation_ala'] = $this->language->get('entry_affirm_checkout_confirmation_ala');
        $data['entry_affirm_homepage_ala'] = $this->language->get('entry_affirm_homepage_ala');
        $data['entry_affirm_homepage_ala_banner_size'] = $this->language->get('entry_affirm_homepage_ala_banner_size');
        $data['entry_total_min'] = $this->language->get('entry_total_min');
        $data['entry_total_max'] = $this->language->get('entry_total_max');
        $data['entry_order_status'] = $this->language->get('entry_order_status');
        $data['entry_pending_status'] = $this->language->get('entry_pending_status');
        $data['entry_canceled_status'] = $this->language->get('entry_canceled_status');
        $data['entry_failed_status'] = $this->language->get('entry_failed_status');
        $data['entry_chargeback_status'] = $this->language->get('entry_chargeback_status');
        $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');
        $data['entry_currency'] = $this->language->get('entry_currency');
        $data['entry_transaction'] = $this->language->get('entry_transaction');
        $data['entry_public_key'] = $this->language->get('entry_public_key');
        $data['entry_private_key'] = $this->language->get('entry_private_key');
        $data['entry_sandbox'] = $this->language->get('entry_sandbox');
        $data['entry_debug'] = $this->language->get('entry_debug');
        $data['entry_payment_method_ala'] = $this->language->get('entry_payment_method_ala');
        $data['entry_affirm_logo_data_type'] = $this->language->get('entry_affirm_logo_data_type');
        $data['entry_affirm_promo_messaging_settings'] = $this->language->get('entry_affirm_promo_messaging_settings');
        $data['entry_affirm_additional_options'] = $this->language->get('entry_affirm_additional_options');
        $data['help_total_min'] = $this->language->get('help_total_min');
        $data['help_total_max'] = $this->language->get('help_total_max');
        $data['help_currency'] = $this->language->get('help_currency');
        $data['help_test'] = $this->language->get('help_test');
        $data['help_status'] = $this->language->get('help_status');
        $data['help_public_key'] = $this->language->get('help_public_key');
        $data['help_private_key'] = $this->language->get('help_private_key');
        $data['help_sandbox'] = $this->language->get('help_sandbox');
        $data['help_checkout_mode'] = $this->language->get('help_checkout_mode');
        $data['help_geo_zone'] = $this->language->get('help_geo_zone');
        $data['help_affirm_enhanced_analytics'] = $this->language->get('help_affirm_enhanced_analytics');
        $data['help_transaction'] = $this->language->get('help_transaction');
        $data['help_debug'] = $this->language->get('help_debug');
        $data['help_sort_order'] = $this->language->get('help_sort_order');
        $data['help_promo_messaging_type'] = $this->language->get('help_promo_messaging_type');
        $data['help_promo_messaging_color'] = $this->language->get('help_promo_messaging_color');
        $data['help_promo_product_messaging'] = $this->language->get('help_promo_product_messaging');
        $data['help_promo_shopping_cart_messaging'] = $this->language->get('help_promo_shopping_cart_messaging');
        $data['help_promo_mini_cart_messaging'] = $this->language->get('help_promo_mini_cart_messaging');
        $data['help_promo_category_product_messaging'] = $this->language->get('help_promo_category_product_messaging');
        $data['help_promo_featured_product_messaging'] = $this->language->get('help_promo_featured_product_messaging');
        $data['help_promo_bestseller_product_messaging'] = $this->language->get('help_promo_bestseller_product_messaging');
        $data['help_promo_latest_product_messaging'] = $this->language->get('help_promo_latest_product_messaging');
        $data['help_promo_specials_product_messaging'] = $this->language->get('help_promo_specials_product_messaging');
        $data['help_promo_product_comparison_messaging'] = $this->language->get('help_promo_product_comparison_messaging');
        $data['help_promo_manufacturer_product_messaging'] = $this->language->get('help_promo_manufacturer_product_messaging');
        $data['help_promo_related_product_messaging'] = $this->language->get('help_promo_related_product_messaging');
        $data['help_promo_checkout_confirmation_messaging'] = $this->language->get('help_promo_checkout_confirmation_messaging');
        $data['help_promo_homepage_banner'] = $this->language->get('help_promo_homepage_banner');
        $data['help_promo_homepage_banner_size'] = $this->language->get('help_promo_homepage_banner_size');
        $data['help_order_status_updates'] = $this->language->get('help_order_status_updates');
        $data['help_authorization_order_status'] = $this->language->get('help_authorization_order_status');
        $data['help_capture_order_status'] = $this->language->get('help_capture_order_status');
        $data['help_refund_order_status'] = $this->language->get('help_refund_order_status');
        $data['help_void_order_status'] = $this->language->get('help_void_order_status');
        $data['help_total_max'] = $this->language->get('help_total_max');
        $data['help_total_min'] = $this->language->get('help_total_min');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');
        $data['currency_codes'] = array('USD');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        $data['default_currency'] = $this->config->get('affirm_currency');
        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['affirm_public_key'])) {
            $data['error_public_key'] = $this->error['affirm_public_key'];
        } else {
            $data['error_public_key'] = '';
        }

        if (isset($this->error['affirm_private_key'])) {
            $data['error_private_key'] = $this->error['affirm_private_key'];
        } else {
            $data['error_private_key'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'] . '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('payment/affirm', 'token=' . $this->session->data['token'], true)
        );

        $data['action'] = $this->url->link('payment/affirm', 'token=' . $this->session->data['token'], true);

        $data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'] . '&type=payment', true);

        if (isset($this->request->post['affirm_status'])) {
            $data['affirm_status'] = $this->request->post['affirm_status'];
        } else {
            $data['affirm_status'] = $this->config->get('affirm_status');
        }

        if (isset($this->request->post['affirm_public_key'])) {
            $data['affirm_public_key'] = $this->request->post['affirm_public_key'];
        } else {
            $data['affirm_public_key'] = $this->config->get('affirm_public_key');
        }

        if (isset($this->request->post['affirm_private_key'])) {
            $data['affirm_private_key'] = $this->request->post['affirm_private_key'];
        } else {
            $data['affirm_private_key'] = $this->config->get('affirm_private_key');
        }


        if (isset($this->request->post['affirm_sandbox'])) {
            $data['affirm_sandbox'] = $this->request->post['affirm_sandbox'];
        } else {
            $data['affirm_sandbox'] = $this->config->get('affirm_sandbox');
        }

        if (isset($this->request->post['affirm_transaction'])) {
            $data['affirm_transaction'] = $this->request->post['affirm_transaction'];
        } else {
            $data['affirm_transaction'] = $this->config->get('affirm_transaction');
        }

        if (isset($this->request->post['affirm_payment_method_ala'])) {
            $data['affirm_payment_method_ala'] = $this->request->post['affirm_payment_method_ala'];
        } else {
            $data['affirm_payment_method_ala'] = $this->config->get('affirm_payment_method_ala');
        }

        if (isset($this->request->post['affirm_currency'])) {
            $data['affirm_currency'] = $this->request->post['affirm_currency'];
        } else {
            $data['affirm_currency'] = $this->config->get('affirm_currency');
        }

        if (isset($this->request->post['affirm_total_min'])) {
            $data['affirm_total_min'] = $this->request->post['affirm_total_min'];
        } else {
            $data['affirm_total_min'] = $this->config->get('affirm_total_min');
        }

        if (isset($this->request->post['affirm_total_max'])) {
            $data['affirm_total_max'] = $this->request->post['affirm_total_max'];
        } else {
            $data['affirm_total_max'] = $this->config->get('affirm_total_max');
        }

        if (isset($this->request->post['affirm_order_status_id'])) {
            $data['affirm_order_status_id'] = $this->request->post['affirm_order_status_id'];
        } elseif ($this->config->get('affirm_order_status_id')) {
            $data['affirm_order_status_id'] = $this->config->get('affirm_order_status_id');
        } else {
            $data['affirm_order_status_id'] = 1;
        }

        if (isset($this->request->post['affirm_no_status_change'])) {
            $data['affirm_no_status_change'] = $this->request->post['affirm_no_status_change'];
        } else {
            $data['affirm_no_status_change'] = $this->config->get('affirm_no_status_change');
        }

        if (isset($this->request->post['affirm_order_refund_status_id'])) {
            $data['affirm_order_refund_status_id'] = $this->request->post['affirm_order_refund_status_id'];
        } elseif ($this->config->get('affirm_order_refund_status_id')) {
            $data['affirm_order_refund_status_id'] = $this->config->get('affirm_order_refund_status_id');
        } else {
            $data['affirm_order_refund_status_id'] = 11;
        }

        if (isset($this->request->post['affirm_order_capture_status_id'])) {
            $data['affirm_order_capture_status_id'] = $this->request->post['affirm_order_capture_status_id'];
        } elseif ($this->config->get('affirm_order_capture_status_id')) {
            $data['affirm_order_capture_status_id'] = $this->config->get('affirm_order_capture_status_id');
        } else {
            $data['affirm_order_capture_status_id'] = 2;
        }

        if (isset($this->request->post['affirm_order_void_status_id'])) {
            $data['affirm_order_void_status_id'] = $this->request->post['affirm_order_void_status_id'];
        } elseif ($this->config->get('affirm_order_void_status_id')) {
            $data['affirm_order_void_status_id'] = $this->config->get('affirm_order_void_status_id');
        } else {
            $data['affirm_order_void_status_id'] = 16;
        }

        if (isset($this->request->post['affirm_order_update_status_id'])) {
            $data['affirm_order_update_status_id'] = $this->request->post['affirm_order_update_status_id'];
        } elseif ($this->config->get('affirm_order_update_status_id')) {
            $data['affirm_order_update_status_id'] = $this->config->get('affirm_order_update_status_id');
        } else {
            $data['affirm_order_update_status_id'] = 3;
        }

        if (isset($this->request->post['affirm_order_shipping_status_id'])) {
            $data['affirm_order_shipping_status_id'] = $this->request->post['affirm_order_shipping_status_id'];
        } elseif ($this->config->get('affirm_order_shipping_status_id')) {
            $data['affirm_order_shipping_status_id'] = $this->config->get('affirm_order_shipping_status_id');
        } else {
            $data['affirm_order_shipping_status_id'] = 3;
        }

        if (isset($this->request->post['affirm_order_complete_status_id'])) {
            $data['affirm_order_complete_status_id'] = $this->request->post['affirm_order_complete_status_id'];
        } elseif ($this->config->get('affirm_order_complete_status_id')) {
            $data['affirm_order_complete_status_id'] = $this->config->get('affirm_order_complete_status_id');
        } else {
            $data['affirm_order_complete_status_id'] = 5;
        }

        if (isset($this->request->post['affirm_geo_zone_id'])) {
            $data['affirm_geo_zone_id'] = $this->request->post['affirm_geo_zone_id'];
        } else {
            $data['affirm_geo_zone_id'] = $this->config->get('affirm_geo_zone_id');
        }

        $this->load->model('localisation/geo_zone');
        $data['affirm_geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        if (isset($this->request->post['affirm_status'])) {
            $data['affirm_status'] = $this->request->post['affirm_status'];
        } else {
            $data['affirm_status'] = $this->config->get('affirm_status');
        }

        if (isset($this->request->post['affirm_debug'])) {
            $data['affirm_debug'] = $this->request->post['affirm_debug'];
        } else {
            $data['affirm_debug'] = $this->config->get('affirm_debug');
        }

        if (isset($this->request->post['affirm_modal_checkout'])) {
            $data['affirm_modal_checkout'] = $this->request->post['affirm_modal_checkout'];
        } else {
            $data['affirm_modal_checkout'] = $this->config->get('affirm_modal_checkout');
        }

        if (isset($this->request->post['affirm_enhanced_analytics'])) {
            $data['affirm_enhanced_analytics'] = $this->request->post['affirm_enhanced_analytics'];
        } else {
            $data['affirm_enhanced_analytics'] = $this->config->get('affirm_enhanced_analytics');
        }

        if (isset($this->request->post['affirm_sort_order'])) {
            $data['affirm_sort_order'] = $this->request->post['affirm_sort_order'];
        } else {
            $data['affirm_sort_order'] = $this->config->get('affirm_sort_order');
        }

        if (isset($this->request->post['affirm_color'])) {
            $data['affirm_color'] = $this->request->post['affirm_color'];
        } else {
            $data['affirm_color'] = $this->config->get('affirm_color');
        }

        if (isset($this->request->post['affirm_logo_data_type'])) {
            $data['affirm_logo_data_type'] = $this->request->post['affirm_logo_data_type'];
        } else {
            $data['affirm_logo_data_type'] = $this->config->get('affirm_logo_data_type');
        }

        if (isset($this->request->post['affirm_mini_cart'])) {
            $data['affirm_mini_cart'] = $this->request->post['affirm_mini_cart'];
        } else {
            $data['affirm_mini_cart'] = $this->config->get('affirm_mini_cart');
        }

        if (isset($this->request->post['affirm_homepage'])) {
            $data['affirm_homepage'] = $this->request->post['affirm_homepage'];
        } else {
            $data['affirm_homepage'] = $this->config->get('affirm_homepage');
        }

        if (isset($this->request->post['affirm_ala_product'])) {
            $data['affirm_ala_product'] = $this->request->post['affirm_ala_product'];
        } else {
            $data['affirm_ala_product'] = $this->config->get('affirm_ala_product');
        }

        if (isset($this->request->post['affirm_ala_featured'])) {
            $data['affirm_ala_featured'] = $this->request->post['affirm_ala_featured'];
        } else {
            $data['affirm_ala_featured'] = $this->config->get('affirm_ala_featured');
        }

        if (isset($this->request->post['affirm_ala_bestseller'])) {
            $data['affirm_ala_bestseller'] = $this->request->post['affirm_ala_bestseller'];
        } else {
            $data['affirm_ala_bestseller'] = $this->config->get('affirm_ala_bestseller');
        }

        if (isset($this->request->post['affirm_ala_latest'])) {
            $data['affirm_ala_latest'] = $this->request->post['affirm_ala_latest'];
        } else {
            $data['affirm_ala_latest'] = $this->config->get('affirm_ala_latest');
        }

        if (isset($this->request->post['affirm_ala_special'])) {
            $data['affirm_ala_special'] = $this->request->post['affirm_ala_special'];
        } else {
            $data['affirm_ala_special'] = $this->config->get('affirm_ala_special');
        }

        if (isset($this->request->post['affirm_ala_compare'])) {
            $data['affirm_ala_compare'] = $this->request->post['affirm_ala_compare'];
        } else {
            $data['affirm_ala_compare'] = $this->config->get('affirm_ala_compare');
        }

        if (isset($this->request->post['affirm_ala_category'])) {
            $data['affirm_ala_category'] = $this->request->post['affirm_ala_category'];
        } else {
            $data['affirm_ala_category'] = $this->config->get('affirm_ala_category');
        }

        if (isset($this->request->post['affirm_ala_checkout_confirm'])) {
            $data['affirm_ala_checkout_confirm'] = $this->request->post['affirm_ala_checkout_confirm'];
        } else {
            $data['affirm_ala_checkout_confirm'] = $this->config->get('affirm_ala_checkout_confirm');
        }

        if (isset($this->request->post['affirm_ala_cart'])) {
            $data['affirm_ala_cart'] = $this->request->post['affirm_ala_cart'];
        } else {
            $data['affirm_ala_cart'] = $this->config->get('affirm_ala_cart');
        }

        if (isset($this->request->post['affirm_ala_manufacturer'])) {
            $data['affirm_ala_manufacturer'] = $this->request->post['affirm_ala_manufacturer'];
        } else {
            $data['affirm_ala_manufacturer'] = $this->config->get('affirm_ala_manufacturer');
        }

        if (isset($this->request->post['affirm_ala_related_product'])) {
            $data['affirm_ala_related_product'] = $this->request->post['affirm_ala_related_product'];
        } else {
            $data['affirm_ala_related_product'] = $this->config->get('affirm_ala_related_product');
        }

        if (isset($this->request->post['affirm_homepage_banner_size'])) {
            $data['affirm_homepage_banner_size'] = $this->request->post['affirm_homepage_banner_size'];
        } else {
            $data['affirm_homepage_banner_size'] = $this->config->get('affirm_homepage_banner_size');
        }

        $data['token'] = $this->session->data['token'];
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('payment/affirm', $data));
    }

    public function order() {
        $this->load->language('payment/affirm');
        $this->load->model('payment/affirm');
        if (!$this->config->get('affirm_status')) {
            return null;
        }
        $order_id = $this->request->get['order_id'];
        $charge_id = '';
        $created = '';
        $shipping_carrier = '';
        $shipping_confirmation = '';
        $order_amount = '';
        $refunded_amount = '';
        $first = '';
        $last = '';
        $full = '';
        $email = '';
        $phone = '';
        $zipcode = '';
        $city = '';
        $state = '';
        $country = '';
        $line1 = '';
        $line2 = '';
        $status = '';
        $q = $this->model_payment_affirm->getChargeId($order_id);
        if ($q) {
            $charge_id = $q['charge_id'];
            $order_amount = $q['amount'];
            $refunded_amount = $q['refunded_amount'];
            $shipping_carrier = $q['shipping_carrier'];
            $first = $q['shipping_name_first'];
            $last = $q['shipping_name_last'];
            $full = $q['shipping_name_full'];
            $email = $q['shipping_email'];
            $phone = $q['shipping_phone'];
            $zipcode = $q['shipping_address_zipcode'];
            $city = $q['shipping_address_city'];
            $state = $q['shipping_address_state'];
            $country = $q['shipping_address_country'];
            $line1 = $q['shipping_address_line1'];
            $line2 = $q['shipping_address_line2'];
            $shipping_confirmation = $q['shipping_confirmation'];
            $status = $q['status'];
            $created = $q['created'];
        }
        $data['charge_id'] = $charge_id;
        $data['chargeID'] = $charge_id;
        $data['created'] = $created;
        $data['token'] = $this->session->data['token'];
        $data['order_id'] = $order_id;
        $data['order_amount'] = $order_amount;
        $data['refunded_amount'] = $refunded_amount;
        $data['shipping_carrier'] = $shipping_carrier;
        $data['shipping_confirmation'] = $shipping_confirmation;
        $data['zipcode'] = $zipcode;
        $data['city'] = $city;
        $data['state'] = $state;
        $data['country'] = $country;
        $data['line1'] = $line1;
        $data['line2'] = $line2;
        $data['first'] = $first;
        $data['last'] = $last;
        $data['full'] = $full;
        $data['email'] = $email;
        $data['phone'] = $phone;
        $data['status'] = $status;
        $data['type'] = "update";
        $data['text_affirm_order_info'] = $this->language->get('text_affirm_order_info');
        $data['text_order_id'] = $this->language->get('text_order_id');
        $data['text_charge_id'] = $this->language->get('text_charge_id');
        return $this->load->view('payment/affirm_order', $data);
    }

    public function refundCharge() {
        $affirm_status_updates = $this->config->get('affirm_no_status_change');
        $affirm_refund_status_id = $this->config->get('affirm_order_refund_status_id');
        $this->load->model('payment/affirm');
        $this->load->model('localisation/order_status');
        $order_id = $this->request->post['order_id'];
        $amount = $this->request->post['amount'];
        $chargeId = $this->request->post['charge_id'];
        if ($amount != '') {
            $response = $this->model_payment_affirm->refundCharge($order_id, $amount, $chargeId);
        } elseif ($amount == 0 || $amount == 000 || $amount == 0.00) {
            $response = $this->model_payment_affirm->refundCharge($order_id, 0, $chargeId);
        } else {
            $response = $this->model_payment_affirm->refundCharge($order_id, '', $chargeId);
        }
        $this->model_payment_affirm->logger($response);

        if ($response['type'] == "refund") {
            $data['created'] = $response['created'];
            $data['type'] = $response['type'];
            $data['transaction_id'] = $response['transaction_id'];
            $data['id'] = $response['id'];
            $data['charge_id'] = $chargeId;
            $data['amount'] = $amount;
            $data['fee_refunded'] = $response['fee_refunded'];
            // Removed partial order status updates
            /* if($this->request->post['amount'] > 0){
              $this->model_payment_affirm->addOrderHistory($this->request->post['order_id'], $affirm_refund_status_id, "Loan ID: ".$chargeId." Partially Refunded.", 0);
              }
              $this->model_payment_affirm->addOrderHistory($this->request->post['order_id'], $affirm_refund_status_id, "Loan ID: ".$chargeId." Refunded.", 0);
             */
            if ($this->request->post['amount'] > 0 && $affirm_status_updates === 1) {
                $this->model_payment_affirm->addOrderHistory($this->request->post['order_id'], $affirm_refund_status_id, "Loan ID: " . $chargeId . " Refunded.", 0);
            } else {
                $this->model_payment_affirm->addOrderHistory($this->request->post['order_id'], $affirm_refund_status_id, "Loan ID: " . $chargeId . " Refunded.", 0);
            }
        }
        if ($response['type'] != "refund") {
            $data['status_code'] = $response['status_code'];
            $data['message'] = $response['message'];
            $data['code'] = $response['code'];
        }
        $this->response->setOutput(json_encode($data));
    }

    public function updateShipping() {
        //$affirm_shipping_status_id = $this->config->get('affirm_order_shipping_status_id');
        $this->load->model('payment/affirm');
        $chargeId = '';
        $city = '';
        $state = '';
        $country = '';
        $first = '';
        $last = '';
        $full = '';
        $line1 = '';
        $line2 = '';
        $zipcode = '';
        $phone = '';
        $email = '';
        $shipping_confirmation = '';
        $shipping_carrier = '';
        if (isset($this->request->post['city'])) {
            $city = $this->request->post['city'];
        } else {
            $city = '';
        }
        if ($city != '') {
            $chargeId = $this->request->post['charge_id'];
            $city = $this->request->post['city'];
            $state = $this->request->post['state'];
            $country = $this->request->post['country'];
            $first = $this->request->post['first'];
            $last = $this->request->post['last'];
            $full = $this->request->post['full'];
            $line1 = $this->request->post['line1'];
            $line2 = $this->request->post['line2'];
            $zipcode = $this->request->post['zipcode'];
            $phone = $this->request->post['phone'];
            $email = $this->request->post['email'];
            if (isset($this->request->post['shipping_confirmation'])) {
                $shipping_confirmation = $this->request->post['shipping_confirmation'];
            } else {
                $shipping_confirmation = null;
            }
            if (isset($this->request->post['shipping_carrier'])) {
                $shipping_carrier = $this->request->post['shipping_carrier'];
            } else {
                $shipping_carrier = null;
            }
            $response = $this->model_payment_affirm->updateShipping($chargeId, $shipping_carrier, $shipping_confirmation, $first, $last, $full, $city, $state, $country, $line1, $line2, $zipcode, $phone, $email);
            if (isset($response['shipping_carrier'])) {
                $data['created'] = $response['created'];
                $data['type'] = $response['type'];
                $data['id'] = $response['id'];
                $data['charge_id'] = $chargeId;
                $data['shipping_carrier'] = $response['shipping_carrier'];
                $data['shipping_confirmation'] = $response['shipping_confirmation'];
                $data['city'] = $response['city'];
                $data['state'] = $response['state'];
                $data['country'] = $response['country'];
                $data['zipcode'] = $response['zipcode'];
                $data['line1'] = $response['line1'];
                $data['line2'] = $response['line2'];
                $data['email'] = $response['email'];
                $data['phone'] = $response['phone'];
                // explicitly removed update order status
                /* $order = array();
                  $order = $this->model_payment_affirm->getByChargeId($chargeId);
                  if ($order) {
                  //print_r($order);die;
                  $this->model_payment_affirm->addOrderHistory($order['order_id'], $affirm_shipping_status_id, "Loan ID: ".$chargeId." Shipping Information Updated.", 0);
                  } */
            } else {
                $data['status_code'] = $response['status_code'];
                $data['message'] = $response['message'];
                $data['code'] = $response['code'];
            }
        }
        $this->response->setOutput(json_encode($response));
    }

    public function updateCharge() {
        $affirm_status_updates = $this->config->get('affirm_no_status_change');
        $affirm_update_status_id = $this->config->get('affirm_order_update_status_id');
        $this->load->model('payment/affirm');
        $chargeId = $this->request->get['charge_id'];
        if (isset($this->request->post['shipping_confirmation'])) {
            $shipping_confirmation = $this->request->post['shipping_confirmation'];
        } else {
            $shipping_confirmation = null;
        }
        if (isset($this->request->post['shipping_carrier'])) {
            $shipping_carrier = $this->request->post['shipping_carrier'];
        } else {
            $shipping_carrier = null;
        }
        $response = $this->model_payment_affirm->updateCharge($chargeId, $shipping_carrier, $shipping_confirmation);
        $this->model_payment_affirm->logger($response);
        if (isset($response['shipping_carrier'])) {
            $data['created'] = $response['created'];
            $data['type'] = $response['type'];
            $data['id'] = $response['id'];
            $data['shipping_carrier'] = $response['shipping_carrier'];
            $data['shipping_confirmation'] = $response['shipping_confirmation'];
            $order = $this->model_payment_affirm->getByChargeId($chargeId);
            if ($order && $affirm_status_updates == 1) {
                $this->model_payment_affirm->addOrderHistory($order['order_id'], $affirm_update_status_id, "Loan ID: " . $chargeId . " Shipping Information Updated.", 0);
            }
        } else {
            $data['status_code'] = $response['status_code'];
            $data['message'] = $response['message'];
            $data['code'] = $response['code'];
        }
        $this->response->setOutput(json_encode($data));
    }

    public function captureCharge() {
        $affirm_status_updates = $this->config->get('affirm_no_status_change');
        $affirm_capture_status_id = $this->config->get('affirm_order_capture_status_id');
        $this->load->model('payment/affirm');
        $order_id = $this->request->post['order_id'];
        $shipping_confirmation = $this->request->post['shipping_confirmation'];
        $shipping_carrier = $this->request->post['shipping_carrier'];
        $response = $this->model_payment_affirm->captureCharge($order_id, $shipping_carrier, $shipping_confirmation);
        $this->model_payment_affirm->logger($response);
        if ($response['type'] == "capture") {
            $data['created'] = $response['created'];
            $data['type'] = $response['type'];
            $data['id'] = $response['id'];
            $data['transaction_id'] = $response['id'];
            $data['order_id'] = $response['order_id'];
            $data['shipping_carrier'] = $response['shipping_carrier'];
            $data['shipping_confirmation'] = $response['shipping_confirmation'];
            $data['fee'] = $response['fee'];
            $order = $this->model_payment_affirm->getChargeId($order_id);
            if ($order && $affirm_status_updates == 1) {
                $this->model_payment_affirm->addOrderHistory($order_id, $affirm_capture_status_id, "Loan ID: " . $order['charge_id'] . " is now processing.", 0);
            }
        }
        if ($response['type'] != "capture") {
            $data['status_code'] = $response['status_code'];
            $data['message'] = $response['message'];
            $data['code'] = $response['code'];
        }
        $this->response->setOutput(json_encode($data));
    }

    public function read() {
        $this->load->model('payment/affirm');
        $chargeId = $this->request->post['charge_id'];
        $response = $this->model_payment_affirm->readCharge($chargeId);
        //$this->model_payment_affirm->logger($response);
        if (isset($response['id'])) {
            $data['created'] = $response['created'];
            $data['entity_name'] = $response['entity_name'];
            $data['currency'] = $response['currency'];
            $data['id'] = $response['id'];
            $data['under_dispute'] = $response['under_dispute'];
            $data['user_id'] = $response['user_id'];
            $data['platform'] = $response['platform'];
            $data['events'] = $response['events'];
            $data['details']['meta']['release'] = $response['details']['meta']['release'];
            $data['details']['meta']['user_timezone'] = $response['details']['meta']['user_timezone'];
            $data['details']['meta']['__affirm_tracking_uuid'] = $response['details']['meta']['__affirm_tracking_uuid'];
            $data['details']['total'] = $response['details']['total'];
            $data['details']['financing_program_external_name'] = $response['details']['financing_program_external_name'];
            $data['details']['financing_program_name'] = $response['details']['financing_program_name'];
            $data['details']['checkout_flow_type'] = $response['details']['checkout_flow_type'];
            $data['details']['billing']['phone_number'] = $response['details']['billing']['phone_number'];
            $data['details']['billing']['email'] = $response['details']['billing']['email'];
            $data['details']['billing']['name']['full'] = $response['details']['billing']['name']['full'];
            $data['details']['billing']['name']['last'] = $response['details']['billing']['name']['last'];
            $data['details']['billing']['name']['first'] = $response['details']['billing']['name']['first'];
            $data['details']['billing']['address']['city'] = $response['details']['billing']['address']['city'];
            $data['details']['billing']['address']['country'] = $response['details']['billing']['address']['country'];
            $data['details']['billing']['address']['zipcode'] = $response['details']['billing']['address']['zipcode'];
            $data['details']['billing']['address']['line1'] = $response['details']['billing']['address']['line1'];
            $data['details']['billing']['address']['line2'] = $response['details']['billing']['address']['line2'];
            $data['details']['billing']['address']['state'] = $response['details']['billing']['address']['state'];
            $data['details']['shipping_amount'] = $response['details']['shipping_amount'];
            if (isset($response['details']['discounts']['discount'])) {
                $data['details']['discounts']['discount'] = $response['details']['discounts']['discount'];
                $data['details']['discounts']['discount']['discount_display_name'] = ['details']['discounts']['discount']['discount_display_name'];
                $data['details']['discounts']['discount']['discount_amount'] = $response['details']['discounts']['discount']['discount_amount'];
            } else {
                $data['discounts']['discount']['discount_display_name'] = '';
                $data['details']['discounts']['discount']['discount_amount'] = '';
                $data['details']['discounts']['discount'] = '';
            }
            $data['details']['config']['user_confirmation_url_action'] = $response['details']['config']['user_confirmation_url_action'];
            $data['details']['api_version'] = $response['details']['api_version'];
            $data['details']['metadata'] = $response['details']['metadata'];
            $data['details']['metadata']['checkout_channel_type'] = $response['details']['metadata']['checkout_channel_type'];
            $data['details']['order_id'] = $response['details']['order_id'];
            if (isset($response['details']['checkout_id'])) {
                $data['details']['checkout_id'] = $response['details']['checkout_id'];
            } else {
                $data['details']['checkout_id'] = null;
            }
            $data['details']['loan_type'] = $response['details']['loan_type'];
            $data['details']['tax_amount'] = $response['details']['tax_amount'];
            $data['details']['checkout_type'] = $response['details']['checkout_type'];
            $data['details']['items'] = $response['details']['items'];
            $data['details']['shipping']['phone_number'] = $response['details']['shipping']['phone_number'];
            $data['details']['shipping']['email'] = $response['details']['shipping']['email'];
            $data['details']['shipping']['name']['full'] = $response['details']['shipping']['name']['full'];
            $data['details']['shipping']['name']['last'] = $response['details']['shipping']['name']['last'];
            $data['details']['shipping']['name']['first'] = $response['details']['shipping']['name']['first'];
            $data['details']['shipping']['address']['city'] = $response['details']['shipping']['address']['city'];
            $data['details']['shipping']['address']['country'] = $response['details']['shipping']['address']['country'];
            $data['details']['shipping']['address']['zipcode'] = $response['details']['shipping']['address']['zipcode'];
            $data['details']['shipping']['address']['line1'] = $response['details']['shipping']['address']['line1'];
            $data['details']['shipping']['address']['line2'] = $response['details']['shipping']['address']['line2'];
            $data['details']['shipping']['address']['state'] = $response['details']['shipping']['address']['state'];
            $data['details']['merchant_external_reference'] = $response['details']['merchant_external_reference'];
            $data['refundable'] = $response['refundable'];
            $data['charge_event_count'] = $response['charge_event_count'];
            $data['pending'] = $response['pending'];
            $data['status'] = $response['status'];
            $data['order_id'] = $response['order_id'];
            $data['void'] = $response['void'];
            $data['expires'] = $response['expires'];
            $data['payable'] = $response['payable'];
            if (isset($response['refund_expires'])) {
                $data['refund_expires'] = $response['refund_expires'];
            } else {
                $data['refund_expires'] = '';
            }
            $data['auth_hold'] = $response['auth_hold'];
            $data['refunded_amount'] = $response['refunded_amount'];
            $data['created'] = $response['created'];
            $data['is_instore'] = $response['is_instore'];
            $data['amount'] = $response['amount'];
            $data['is_marqeta_charge'] = $response['is_marqeta_charge'];
            $data['balance'] = $response['balance'];
            $data['financing_program'] = $response['financing_program'];
        } else {
            if (isset($response['message'])) {
                $data['status_code'] = $response['status_code'];
                $data['message'] = $response['message'];
                $data['code'] = $response['code'];
            }
        }
        $this->response->setOutput(json_encode($response));
    }

    public function void() {
        $affirm_status_updates = $this->config->get('affirm_no_status_change');
        $affirm_void_status_id = $this->config->get('affirm_order_void_status_id');
        $this->load->model('payment/affirm');
        $chargeId = $this->request->post['charge_id'];
        $response = $this->model_payment_affirm->voidCharge($chargeId);
        $this->model_payment_affirm->logger($response);
        if ($response['type'] == "void") {
            $data['created'] = $response['created'];
            $data['type'] = $response['type'];
            $data['id'] = $response['id'];
            $order = $this->model_payment_affirm->getByChargeId($chargeId);
            if ($order && $affirm_status_updates == 1) {
                $this->model_payment_affirm->addOrderHistory($order['order_id'], $affirm_void_status_id, "Loan ID: " . $chargeId . " order voided.", 0);
            }
        } else {
            $data['status_code'] = $response['status_code'];
            $data['message'] = $response['message'];
            $data['code'] = $response['code'];
        }
        $this->response->setOutput(json_encode($data));
    }

    public function refund() {
        $affirm_status_updates = $this->config->get('affirm_no_status_change');
        $affirm_refund_status_id = $this->config->get('affirm_order_refund_status_id');
        $this->load->language('payment/affirm');
        if (isset($this->request->post['charge_id']) && !empty($this->request->post['charge_id'])) {
            $this->load->model('payment/affirm');
            $data = array();
            $affirm_order = $this->model_payment_affirm->getChargeId($this->request->post['order_id']);
            $refund_response = $this->model_payment_affirm->refundCharge($affirm_order['charge_id'], $this->request->post['amount']);
            $this->model_payment_affirm->logger($refund_response);
            $data['created'] = $response['created'];
            $data['type'] = $response['type'];
            $data['transaction_id'] = $response['transaction_id'];
            $data['fee_refunded'] = $response['fee_refunded'];
            $data['amount'] = $response['amount'];
            if ($affirm_status_updates == 1) {
                $this->model_payment_affirm->addOrderHistory($this->request->post['order_id'], $affirm_refund_status_id, "Loan ID: " . $chargeId . " Order refunded.", 0);
            }
            $this->response->setOutput(json_encode($data));
        }
    }

    public function install() {
        $this->load->model('payment/affirm');
        $this->model_payment_affirm->install();
    }

    public function uninstall() {
        $this->load->model('payment/affirm');
        $this->model_payment_affirm->uninstall();
    }

    protected function validate() {
        if (!$this->user->hasPermission('modify', 'payment/affirm')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        if (!$this->request->post['affirm_public_key']) {
            $this->error['affirm_public_key'] = $this->language->get('error_public_key');
        }
        if (!$this->request->post['affirm_private_key']) {
            $this->error['affirm_private_key'] = $this->language->get('error_private_key');
        }
        return !$this->error;
    }
}
