<?php

/* OpenCart 2.2.x OCmod
*  Affirm 2019 */

class ModelPaymentAffirm extends Model {

    public function formatPrice($usd) {
        return number_format((float) $usd, 2, '.', '') * 100;
    }

    public function getLookupByOrderId($order_id) {
        return $this->db->query("SELECT * FROM `" . DB_PREFIX . "affirm_order` WHERE `order_id` = " . $order_id . "");
    }

    public function getLookupByChargeId($charge_id) {
        return $this->db->query("SELECT * FROM `" . DB_PREFIX . "affirm_order` WHERE `charge_id` = '" . $charge_id . "'");
    }

    public function getAffirmOrder($charge_id) {
        return $this->getLookupByChargeId($charge_id);
    }

    public function getAffirmOrderById($order_id) {
        return $this->getLookupByOrderId($order_id);
    }

    public function getChargeId($order_id) {
        if($order_id != null){
            $q = $this->getAffirmOrderById($order_id);
            if ($q->num_rows) {
                $affirm_order = array();
                $affirm_order = $q->row;
                $affirm_order['charge_id'] = $q->row['charge_id'];
                $affirm_order['amount'] = $q->row['amount'];
                $affirm_order['created'] = $q->row['created'];
                $affirm_order['fee'] = $q->row['fee'];
                $affirm_order['transaction_id'] = $q->row['transaction_id'];
                $affirm_order['refunded_amount'] = $q->row['refunded_amount'];
                $affirm_order['shipping_carrier'] = $q->row['shipping_carrier'];
                $affirm_order['shipping_confirmation'] = $q->row['shipping_confirmation'];
                $affirm_order['zipcode'] = $q->row['shipping_address_zipcode'];
                $affirm_order['city'] = $q->row['shipping_address_city'];
                $affirm_order['state'] = $q->row['shipping_address_state'];
                $affirm_order['country'] = $q->row['shipping_address_country'];
                $affirm_order['line1'] = $q->row['shipping_address_line1'];
                $affirm_order['line2'] = $q->row['shipping_address_line2'];
                $affirm_order['phone'] = $q->row['shipping_phone'];
                $affirm_order['email'] = $q->row['shipping_email'];
                $affirm_order['order_id'] = $order_id;
                return $affirm_order;
            } 
        }
        else{ return false; }
    }

    public function getByChargeId($charge_id) {
        $q = $this->getAffirmOrder($charge_id);
        if ($q->num_rows) {
            $affirm_order = array();
            $affirm_order = $q->row;
            $affirm_order['charge_id'] = $q->row['charge_id'];
            $affirm_order['amount'] = $q->row['amount'];
            $affirm_order['created'] = $q->row['created'];
            $affirm_order['fee'] = $q->row['fee'];
            $affirm_order['transaction_id'] = $q->row['transaction_id'];
            $affirm_order['refunded_amount'] = $q->row['refunded_amount'];
            $affirm_order['shipping_carrier'] = $q->row['shipping_carrier'];
            $affirm_order['shipping_confirmation'] = $q->row['shipping_confirmation'];
            $affirm_order['zipcode'] = $q->row['shipping_address_zipcode'];
            $affirm_order['city'] = $q->row['shipping_address_city'];
            $affirm_order['state'] = $q->row['shipping_address_state'];
            $affirm_order['country'] = $q->row['shipping_address_country'];
            $affirm_order['line1'] = $q->row['shipping_address_line1'];
            $affirm_order['line2'] = $q->row['shipping_address_line2'];
            $affirm_order['phone'] = $q->row['shipping_phone'];
            $affirm_order['email'] = $q->row['shipping_email'];
            $affirm_order['order_id'] = $q->row['order_id'];
            return $affirm_order;
        } else {
            return false;
        }
    }

    public function addOrderHistory($order_id, $order_status_id, $comment, $notify) {
        $this->db->query("UPDATE `" . DB_PREFIX . "order` SET `order_status_id` = '" . (int) $order_status_id . "', date_modified = NOW() WHERE order_id = '" . (int) $order_id . "'");
        return $this->db->query("INSERT INTO `" . DB_PREFIX . "order_history` SET `order_id` = '" . (int) $order_id . "', order_status_id = '" . (int) $order_status_id . "', notify = '" . (int) $notify . "', comment = '" . $this->db->escape(strip_tags($comment)) . "', date_added = NOW()");
    }

    public function captureCharge($order_id, $shippingCarrier, $trackingNumber) {
        $sandbox = $this->config->get('affirm_sandbox');
        $data = array('order_id' => $order_id, 'shipping_carrier' => $shippingCarrier, 'shipping_confirmation' => $trackingNumber);
        $charge = $this->getChargeId($order_id);
        $chargeId = $charge['charge_id'];
        if ($sandbox) {
            $response = $this->PostCaptureAffirm(true, $data, $chargeId);
        } else {
            $response = $this->PostCaptureAffirm(false, $data, $chargeId);
        }
        if ($response['type'] != 'capture') {
            $this->db->query("INSERT INTO `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "', `type` = '" . $response['type'] . "', `message` = '" . $this->db->escape($response['message']) . "'");
        } else {
            $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET `charge_id` = '" . $chargeId . "', `type` = '" . $response['type'] . "', `created` = '" . $response['created'] . "', `shipping_carrier` = '" . $this->db->escape($response['shipping_carrier']) . "',`shipping_confirmation` = '" . $this->db->escape($response['shipping_confirmation']) . "', `fee` = '" . $this->db->escape($response['fee']) . "', `transaction_id` = '" . $this->db->escape($response['transaction_id']) . "', `amount` = '" . $this->db->escape($response['amount']) . "' WHERE `charge_id` = '" . $chargeId . "'");
        }
        return $response;
    }

    public function updateShipping($chargeId, $shipping_carrier, $shipping_confirmation, $first, $last, $full, $city, $state, $country, $line1, $line2, $zipcode, $phone, $email) {
        $sandbox = $this->config->get('affirm_sandbox');
        $shipping = array('shipping_carrier' => $shipping_carrier, 'shipping_confirmation' => $shipping_confirmation, "shipping" => array("address" => array('city' => $city, 'state' => $state, 'country' => $country, 'line1' => $line1, 'line2' => $line2, 'zipcode' => $zipcode), array("name" => array('first' => $first, 'last' => $last, 'full' => $full), 'phone' => $phone, 'email' => $email)));
        if ($sandbox) {
            $response = $this->PostUpdateAffirm(true, $shipping, $chargeId);
        } else {
            $response = $this->PostUpdateAffirm(false, $shipping, $chargeId);
        }
        $response['city'] = $this->db->escape($response['shipping']['address']['city']);
        $response['shipping_carrier'] = $this->db->escape($response['shipping_carrier']);
        $response['shipping_confirmation'] = $this->db->escape($response['shipping_confirmation']);
        $response['line1'] = $this->db->escape($response['shipping']['address']['line1']);
        $response['line2'] = $this->db->escape($response['shipping']['address']['line2']);
        $response['zipcode'] = $this->db->escape($response['shipping']['address']['zipcode']);
        $response['state'] = $this->db->escape($response['shipping']['address']['state']);
        $response['country'] = $this->db->escape($response['shipping']['address']['country']);
        $response['email'] = $this->db->escape($response['shipping'][0]['email']);
        $response['phone'] = $this->db->escape($response['shipping'][0]['phone']);
        $response['first'] = $this->db->escape($response['shipping'][0]['name']['first']);
        $response['last'] = $this->db->escape($response['shipping'][0]['name']['last']);
        $response['full'] = $this->db->escape($response['shipping'][0]['name']['full']);
        $response['type'] = $this->db->escape("update");
        if (isset($response['shipping'])) {
            $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET              
            `type` = '" . $this->db->escape("update") . "',
            `shipping_carrier` = '" . $this->db->escape($response['shipping_carrier']) . "',
            `shipping_confirmation` = '" . $this->db->escape($response['shipping_confirmation']) . "',
            `shipping_address_city` = '" . $this->db->escape($response['shipping']['address']['city']) . "',
            `shipping_address_line1` = '" . $this->db->escape($response['shipping']['address']['line1']) . "',
            `shipping_address_line2` = '" . $this->db->escape($response['shipping']['address']['line2']) . "',
            `shipping_address_zipcode` = '" . $this->db->escape($response['shipping']['address']['zipcode']) . "',
            `shipping_address_state` = '" . $this->db->escape($response['shipping']['address']['state']) . "',
            `shipping_address_country` = '" . $this->db->escape($response['shipping']['address']['country']) . "',
            `shipping_name_first` = '" . $this->db->escape($response['shipping'][0]['name']['first']) . "',
            `shipping_name_last` = '" . $this->db->escape($response['shipping'][0]['name']['last']) . "', 
            `shipping_name_full` = '" . $this->db->escape($response['shipping'][0]['name']['full']) . "',
            `shipping_email` = '" . $this->db->escape($response['email']) . "',
            `shipping_phone` = '" . $this->db->escape($response['phone']) . "' WHERE `charge_id` = '" . $chargeId . "'");
        }
        //$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "',`type` = '" . $this->db->escape($response['type']) . "'");
        return $response;
    }

    public function updateCharge($chargeId, $shippingCarrier, $trackingNumber) {
        $sandbox = $this->config->get('affirm_sandbox');
        $data = array('charge_id' => $chargeId, 'shipping_carrier' => $shippingCarrier, 'shipping_confirmation' => $trackingNumber);
        if ($sandbox) {
            $response = $this->PostUpdateAffirm(true, $data, $chargeId);
        } else {
            $response = $this->PostUpdateAffirm(false, $data, $chargeId);
        }
        $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET 
            `charge_id` = '" . $chargeId . "',
            `shipping_carrier` = '" . $this->db->escape($shippingCarrier) . "',
            `shipping_confirmation` = '" . $this->db->escape($trackingNumber) . "' WHERE `charge_id` = '" . $chargeId . "'");
        //$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "',`type` = '" . $this->db->escape($response['type']) . "'");
        return $response;
    }

    public function refundCharge($order_id, $refundAmount, $charge_id) {
        $sandbox = $this->config->get('affirm_sandbox');
        if ($refundAmount == '') {
            $data = '';
        } else {
            $data = array('amount' => $this->formatPrice($refundAmount));
        }
        //$order = $this->getChargeId($order_id);
        if ($sandbox) {
            $response = $this->PostRefundAffirm(true, $data, $charge_id);
        } else {
            $response = $this->PostRefundAffirm(false, $data, $charge_id);
        }
        if ($response['type'] == "refund") {
            $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET `fee_refunded` = '" . $response['fee_refunded'] . "', `refunded_amount` = '" . $this->db->escape($response['amount']) . "', `type` ='" . $response['type'] . "', `status` = 'refunded' WHERE `charge_id` = '" . $charge_id . "'");
            //$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "',`type` = 'refund', `message` = 'Amount refunded: ''" . $this->db->escape($response['amount']) . "'");
            return $response;
        } else {
            return $response;
        }
    }

    public function readCharge($chargeId) {
        $sandbox = $this->config->get('affirm_sandbox');
        $affirm_order = array();
        if ($sandbox) {
            $response = $this->GetReadAffirm(true, $chargeId);
        } else {
            $response = $this->GetReadAffirm(false, $chargeId);
        }
        $q = $this->getAffirmOrder($chargeId);
        if ($q->num_rows) {
            $affirm_order = $q->row;
            $affirm_order['charge_id'] = $q->row['charge_id'];
            $affirm_order['order_id'] = $q->row['order_id'];
            $affirm_order['amount'] = $q->row['amount'];
            $affirm_order['created'] = $q->row['created'];
            $affirm_order['fee'] = $q->row['fee'];
            $affirm_order['transaction_id'] = $q->row['transaction_id'];
            $affirm_order['refunded_amount'] = $q->row['refunded_amount'];
            $affirm_order['shipping_carrier'] = $q->row['shipping_carrier'];
            $affirm_order['shipping_confirmation'] = $q->row['shipping_confirmation'];
            $affirm_order['zipcode'] = $q->row['shipping_address_zipcode'];
            $affirm_order['city'] = $q->row['shipping_address_city'];
            $affirm_order['state'] = $q->row['shipping_address_state'];
            $affirm_order['country'] = $q->row['shipping_address_country'];
            $affirm_order['line1'] = $q->row['shipping_address_line1'];
            $affirm_order['line2'] = $q->row['shipping_address_line2'];
            $affirm_order['phone'] = $q->row['shipping_phone'];
            $affirm_order['email'] = $q->row['shipping_email'];
            $affirm_order['first'] = $q->row['shipping_name_first'];
            $affirm_order['last'] = $q->row['shipping_name_last'];
            $affirm_order['full'] = $q->row['shipping_name_full'];
            if (isset($response)) {
                $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET 
                `shipping_address_zipcode` = '" . $this->db->escape($response['details']['shipping']['address']['zipcode']) . "',
                `shipping_address_city` = '" . $this->db->escape($response['details']['shipping']['address']['city']) . "',
                `shipping_address_state` = '" . $this->db->escape($response['details']['shipping']['address']['state']) . "', 
                `shipping_address_country` = '" . $this->db->escape($response['details']['shipping']['address']['country']) . "',
                `shipping_address_line1` = '" . $this->db->escape($response['details']['shipping']['address']['line1']) . "',
                `shipping_address_line2` = '" . $this->db->escape($response['details']['shipping']['address']['line2']) . "',  
                `shipping_phone` = '" . $this->db->escape($response['details']['shipping']['phone_number']) . "',
                `shipping_email` = '" . $this->db->escape($response['details']['shipping']['email']) . "',  
                `shipping_name_first` = '" . $this->db->escape($response['details']['shipping']['name']['first']) . "',
                `shipping_name_last` = '" . $this->db->escape($response['details']['shipping']['name']['last']) . "',
                `shipping_name_full` = '" . $this->db->escape($response['details']['shipping']['name']['full']) . "',
                `order_id` = '" . $this->db->escape($response['order_id']) . "' WHERE `charge_id` = '" . $chargeId . "'");
                } else {
                    $affirm_order['shipping_carrier'] = $q->row['shipping_carrier'];
                    $affirm_order['shipping_confirmation'] = $q->row['shipping_confirmation'];
                    $affirm_order['shipping_address_zipcode'] = $q->row['shipping_address_zipcode'];
                    $affirm_order['shipping_address_city'] = $q->row['shipping_address_city'];
                    $affirm_order['shipping_address_state'] = $q->row['shipping_address_state'];
                    $affirm_order['shipping_address_country'] = $q->row['shipping_address_country'];
                    $affirm_order['shipping_address_country'] = $q->row['shipping_address_line1'];
                    $affirm_order['shipping_address_line2'] = $q->row['shipping_address_line2'];
                    $affirm_order['shipping_phone'] = $q->row['shipping_phone'];
                    $affirm_order['shipping_email'] = $q->row['shipping_email'];
                    $affirm_order['shipping_name_first'] = $q->row['shipping_name_first'];
                    $affirm_order['shipping_name_last'] = $q->row['shipping_name_last'];
                    $affirm_order['shipping_name_full'] = $q->row['shipping_name_full'];
                }
                if (isset($response['created'])) {
                    $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET 
                    `status` = '" . $this->db->escape($response['status']) . "',
                    `created` = '" . $this->db->escape($response['created']) . "',
                    `amount` = '" . $this->db->escape($response['amount']) . "',
                    `auth_hold` = '" . $this->db->escape($response['auth_hold']) . "',
                    `payable` = '" . $this->db->escape($response['payable']) . "',
                    `void` = '" . $this->db->escape($response['void']) . "',
                    `expires` = '" . $this->db->escape($response['expires']) . "',
                    `order_id` = '" . $this->db->escape($response['order_id']) . "' WHERE `charge_id` = '" . $chargeId . "'");
                }
        }
        //$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "',`type` = 'void', `message` = 'Order '" . $this->db->escape($response['order_id']) . "' information sync at : '" . $this->db->escape($response['created']) . "'");
        return $response;
    }

    public function voidCharge($chargeId) {
        $sandbox = $this->config->get('affirm_sandbox');
        if ($sandbox) {
            $response = $this->PostVoidAffirm(true, $chargeId);
        } else {
            $response = $this->PostVoidAffirm(false, $chargeId);
        }
        if ($response['type'] == "void") {
            $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET `type` = '" . $this->db->escape($response['type']) . "', `transaction_id` = '" . $this->db->escape($response['transaction_id']) . "', `created` = '" . $this->db->escape($response['created']) . "' WHERE `charge_id` = '" . $chargeId . "'");
            //$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "',`type` = '" . $this->db->escape($response['type']) . "', `message` = 'Order '" . $this->db->escape($response['order_id']) . "' voided at : ''" . $this->db->escape($response['created']) . "'");
            return $response;
        } else {
            return $response;
        }
    }

    private function PostCaptureAffirm($sandbox, $data, $chargeId) {
        $request = json_encode($data);
        $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
        $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
        if ($sandbox) {
            $url = $sandbox_auth_url;
        } else {
            $url = $live_auth_url;
        }
        $public_key = $this->config->get('affirm_public_key');
        $private_key = $this->config->get('affirm_private_key');
        if ($public_key != null) {
            $keypair = $public_key . ':' . $private_key;
            $capturePayment = $url . '' . $chargeId . '/capture';
            $headers[] = 'Accept-Charset: utf-8';
            $headers[] = 'Content-Type: application/json';
            $this->lastHeaders = $headers;
            $curl = curl_init($capturePayment);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($curl, CURLOPT_URL, $capturePayment);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_USERPWD, $keypair);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
            $resp = curl_exec($curl);
            $response = json_decode($resp, true);
            curl_close($curl);
            return $response;
        } else {
            throw new Exception("Missing API key.");
            return "Missing API key.";
        }
    }

    private function PostUpdateAffirm($sandbox, $data, $chargeId) {
        $request = json_encode($data);
        $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
        $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
        if ($sandbox) {
            $url = $sandbox_auth_url;
        } else {
            $url = $live_auth_url;
        }
        $public_key = $this->config->get('affirm_public_key');
        $private_key = $this->config->get('affirm_private_key');
        if ($public_key != null) {
            $keypair = $public_key . ':' . $private_key;
            $capturePayment = $url . '' . $chargeId . '/update';
            $headers[] = 'Accept-Charset: utf-8';
            $headers[] = 'Content-Type: application/json';
            $this->lastHeaders = $headers;
            $curl = curl_init($capturePayment);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($curl, CURLOPT_URL, $capturePayment);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_USERPWD, $keypair);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
            $resp = curl_exec($curl);
            $response = json_decode($resp, true);
            curl_close($curl);
            return $response;
        } else {
            throw new Exception("Missing API key.");
            return "Missing API key.";
        }
    }

    private function PostRefundAffirm($sandbox, $data, $chargeId) {
        if (isset($data)) {
            $request = json_encode($data);
        }
        $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
        $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
        if ($sandbox) {
            $url = $sandbox_auth_url;
        } else {
            $url = $live_auth_url;
        }
        $public_key = $this->config->get('affirm_public_key');
        $private_key = $this->config->get('affirm_private_key');
        if ($public_key != null) {
            $keypair = $public_key . ':' . $private_key;
            $capturePayment = $url . '' . $chargeId . '/refund';
            $headers[] = 'Accept-Charset: utf-8';
            $headers[] = 'Content-Type: application/json';
            $this->lastHeaders = $headers;
            $curl = curl_init($capturePayment);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($curl, CURLOPT_URL, $capturePayment);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_USERPWD, $keypair);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            if ($data != '') {
                curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
            }
            $resp = curl_exec($curl);
            $response = json_decode($resp, true);
            curl_close($curl);
            return $response;
        } else {
            throw new Exception("Missing API key.");
            return "Missing API key.";
        }
    }

    private function PostVoidAffirm($sandbox, $chargeId) {
        $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
        $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
        if ($sandbox) {
            $url = $sandbox_auth_url;
        } else {
            $url = $live_auth_url;
        }
        $public_key = $this->config->get('affirm_public_key');
        $private_key = $this->config->get('affirm_private_key');
        if ($public_key != null) {
            $keypair = $public_key . ':' . $private_key;
            $voidPayment = $url . '' . $chargeId . '/void';
            $headers[] = 'Accept-Charset: utf-8';
            $headers[] = 'Content-Type: application/json';
            $this->lastHeaders = $headers;
            $curl = curl_init($voidPayment);
            curl_setopt($curl, CURLOPT_URL, $voidPayment);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($curl, CURLOPT_USERPWD, $keypair);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            $resp = curl_exec($curl);
            $response = json_decode($resp, true);
            curl_close($curl);
            return $response;
        } else {
            throw new Exception("Missing API key.");
            return "Missing API key.";
        }
    }

    private function GetReadAffirm($sandbox, $chargeId) {
        $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
        $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
        if ($sandbox) {
            $url = $sandbox_auth_url;
        } else {
            $url = $live_auth_url;
        }
        $public_key = $this->config->get('affirm_public_key');
        $private_key = $this->config->get('affirm_private_key');
        if ($public_key != null) {
            $keypair = $public_key . ':' . $private_key;
            $readCharge = $url . '' . $chargeId;
            $headers[] = 'Accept-Charset: utf-8';
            $headers[] = 'Content-Type: application/json';
            $this->lastHeaders = $headers;
            $curl = curl_init($readCharge);
            curl_setopt($curl, CURLOPT_URL, $readCharge);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_USERPWD, $keypair);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            $resp = curl_exec($curl);
            $response = json_decode($resp, true);
            curl_close($curl);
            return $response;
        } else {
            throw new Exception("Missing API key.");
            return "Missing API key.";
        }
    }

    private function PostAuthorizationAffirm($sandbox, $data) {
        $request = json_encode($data);
        $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
        $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
        if ($sandbox) {
            $url = $sandbox_auth_url;
        } else {
            $url = $live_auth_url;
        }
        $public_key = $this->config->get('affirm_public_key');
        $private_key = $this->config->get('affirm_private_key');
        if ($public_key != null) {
            $keypair = $public_key . ':' . $private_key;
            $capturePayment = $url;
            $headers[] = 'Accept-Charset: utf-8';
            $headers[] = 'Content-Type: application/json';
            $this->lastHeaders = $headers;
            $curl = curl_init($capturePayment);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($curl, CURLOPT_URL, $capturePayment);
            curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($curl, CURLOPT_USERPWD, $keypair);
            curl_setopt($curl, CURLOPT_HEADER, false);
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
            $resp = curl_exec($curl);
            $response = json_decode($resp, true);
            curl_close($curl);
            return $response;
        } else {
            throw new Exception("There was an issue authorizing your Affirm loan. Please check out again or use a different payment method.");
            return "There was an issue authorizing your Affirm loan. Please check out again or use a different payment method.";
        }
    }

    public function currencyCode() {
        return array('USD');
    }

    public function install() {
        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "affirm_event` (
        `event_id` int NOT NULL AUTO_INCREMENT,
        `affirm_id` varchar(191) NOT NULL,
        `type` varchar(10) NOT NULL,
        `message` text, 
        `status` varchar(10),
        `code` varchar(10), 
        `created` varchar(64),
        `stamp` varchar(64),
        PRIMARY KEY (`event_id`)
        ) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;");
        
        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "affirm_marketing` (
        `promo_id` int NOT NULL AUTO_INCREMENT,
        `area` varchar(191) NOT NULL,
        `type` varchar(191), 
        `class` varchar(191),
        `amount` varchar(30), 
        `color` varchar(30) NOT NULL,
        `promo_external_id` varchar(128),
        `aff_cid` varchar(191),
        `aff_fm` varchar(10),
        `footer` text,
        `description` text,
        `headline` text,
        `tagline` text, 
        `html_ala` text, 
        `ala` text, 
        `content_space_1` varchar(191),
        `content_space_2` varchar(191),
        `config_color` varchar(191),
        `config_fontFamily` varchar(191),
        `promo_prequal_enabled` varchar(1),
        `promo_style` varchar(191),
        `image_hero` varchar(191),
        `image_hero2x` varchar(191),
        `image_logo` varchar(191),
        `image_logo2x` varchar(191),
        `button` varchar(191),
        `offer_terms` text,
        `offer_expiry` varchar(191),       
        `educational_page_url` varchar(191),
        `product_id` int(11),
        `category_id` int(11),
        `page_id` int(11),
        `created` varchar(64),
        `status` varchar(1),
        PRIMARY KEY (`promo_id`)
        ) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;");
        
        $this->db->query("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "affirm_order` (
        `order_id` int NOT NULL,  
        `charge_id` varchar(64) NOT NULL, 
        `merchant_id` varchar(64),
        `affirm_id` varchar(64) NOT NULL, 
        `type` varchar(40),
        `financing_program` varchar(64),  
        `created` varchar(64),
        `checkout_type` varchar(191), 
        `refundable` varchar(40),
        `transaction_id` varchar(64) NOT NULL,
        `user_id` int(11),
        `customer_name` varchar(191),
        `customer_email` varchar(191),
        `fee` varchar(32),
        `amount` varchar(32) NOT NULL,
        `balance` varchar(32),
        `tax_amount` varchar(32),
        `shipping_amount` varchar(32),
        `refunded_amount` varchar(32), 
        `fee_refunded` varchar(32),
        `order_amount` varchar(32),
        `payable` varchar(32),
        `shipping_carrier` varchar(191),
        `shipping_confirmation` varchar(191), 
        `shipping_address_city` varchar(191), 
        `shipping_address_state` varchar(64),
        `shipping_address_country` varchar(74),
        `shipping_address_zipcode` varchar(40), 
        `shipping_address_line1` varchar(191),  
        `shipping_address_line2` varchar(191),
        `shipping_name_first` varchar(90),
        `shipping_name_last` varchar(90),
        `shipping_name_full` varchar(191),    
        `shipping_phone` varchar(40),
        `shipping_email` varchar(191),
        `auth_hold` varchar(40),
        `void` varchar(40),
        `expires` varchar(40),
        `merchant_external_reference` text,
        `message` varchar(191),
        `pending` varchar(191),
        `status_code` varchar(40), 
        `status` varchar(40), 
        `stamp` varchar(64),
        `code` varchar(40),
        PRIMARY KEY (`order_id`)
        ) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;");
    }

    public function uninstall() {
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "affirm_event`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "affirm_marketing`;");
        $this->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "affirm_order`;");
    }

    public function logger($message) {
        if ($this->config->get('affirm_debug') == 1) {
            $log = new Log('affirm_admin.log');
            $backtrace = debug_backtrace();
            $class = isset($backtrace[6]['class']) ? $backtrace[6]['class'] . '::' : '';
            $log->write('Log: ' . $class . $backtrace[6]['function']);
            $log->write(!is_string($message) ? print_r($message, true) : $message);
            // Moved unset function to retain log details. Now log will be removed if debug is set to false/0.
            //unset($log);
        }
        else
        {
           unset($log); 
        }
    }
}